//+------------------------------------------------------------------+
//|                                                          PFE.mq4 |
//|                             2008, giampiero.raschetti@gmail.com |
//|                                            http://www.fxtrade.it |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Gimapiero Raschetti"
#property link      "http://www.fxtrade.it/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DodgerBlue
#property indicator_level1  0


extern int    PfePeriod       = 5;
extern bool   UseAvarage      = true;
extern int    MaPeriod        = 5;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double Pfe[];
double PfeBuffer[];
double trend[];

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,Pfe);
   SetIndexBuffer(1,PfeBuffer);
   SetIndexBuffer(2,trend);
   IndicatorShortName("PFE("+PfePeriod+")");
  
return(0);
}

//
//
//
//
//

int start()
{
   int  counted_bars=IndicatorCounted();
   int  i,limit;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for (i = limit; i >= 0 ; i--)
   {
      double noise=0.000000001; for(int k=0; k<PfePeriod && (i+k)>=0; k++) noise=noise+MathAbs(Close[i+k]-Close[i+k+1]); 
      
      PfeBuffer[i]=(Close[i]-Close[i+PfePeriod])/noise;
   }
   for (i = limit; i >= 0 ; i--)
   {
      if(UseAvarage) Pfe[i]=iMAOnArray(PfeBuffer,Bars,MaPeriod,0,MODE_EMA,i);
      else           Pfe[i]=PfeBuffer[i];
      
      trend[i] = trend[i+1];
      if (Pfe[i]>0) trend[i] = 1;
      if (Pfe[i]<0) trend[i] =-1;  
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," PFE ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," PFE "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

